<template>
  <section>
    <div class="columns">
      <div class="column is-10">
        <b-field class="columns is-4 mt-type">
          <b-checkbox-button
            v-model="idTypeActiviteData"
            :native-value="typeActivite.id"
            :class="resolveTypeActivite({ typeActivite }, 'mt-type-').class"
            @input="afficherNotif = !afficherNotif"
          >
            <span>{{ typeActivite.libelle }}</span>
            <b-icon :icon="typeActivite.codeCssIcone" />
          </b-checkbox-button>
        </b-field>
      </div>
      <b-switch v-if="afficherNotif" v-model="selectNotif" class="column is-2" @input="changeSwitch" />
    </div>
    <div v-if="afficherNotif">
      <article :class="resolveBorderTypeActivite(typeActivite, 'mt-border-').class">
        <div class="position-titre">
          <div class="columns position-champ-notif ">
            <h3 class="column is-6 is-size-6 has-text-weight-bold">Gestion des activités</h3>
            <p class="column is-3">In App</p>
            <p class="column is-3">Email</p>
          </div>
          <label class="is-size-8 has-text-weight-light">Je souhaite recevoir les alertes/notifications de : </label>
        </div>
        <div class="position-notification">
          <type-notification-selection
            :titre="'Création d\'une activité'"
            :notification-in-app="notification.notifAppActiviteCree"
            :notification-mail="notification.notifMailActiviteCree"
            :activer-checkbox="false"
            :select-notif="selectNotif1"
            @modif-notif-app="updateNotification((notification.notifAppActiviteCree = $event))"
            @modif-notif-mail="updateNotification((notification.notifMailActiviteCree = $event))"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Modification d\'une activité'"
            :notification-in-app="notification.notifAppActiviteModif"
            :notification-mail="notification.notifMailActiviteModif"
            :activer-checkbox="false"
            :select-notif="selectNotif1"
            class="mt-surbrillance"
            @modif-notif-app="updateNotification((notification.notifAppActiviteModif = $event))"
            @modif-notif-mail="updateNotification((notification.notifMailActiviteModif = $event))"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Rappels d\'une activité'"
            :notification-in-app="notification.notifAppActiviteRappel"
            :notification-mail="notification.notifMailActiviteRappel"
            :activer-checkbox="true"
            :select-notif="null"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Suppression d\'une activité'"
            :notification-in-app="notification.notifAppActiviteSupp"
            :notification-mail="notification.notifMailActiviteSupp"
            :activer-checkbox="true"
            :select-notif="null"
            class="mt-surbrillance"
          ></type-notification-selection>
        </div>
      </article>
      <article :class="resolveBorderTypeActivite(typeActivite, 'mt-border-').class">
        <div class="position-titre">
          <div class="columns position-champ-notif">
            <h3 class="column is-6 has-text-weight-bold">Gestion des candidatures</h3>
            <p class="column is-3">In App</p>
            <p class="column is-3">Email</p>
          </div>
          <label class="is-size-8 has-text-weight-light">Je souhaite recevoir les alertes/notifications de : </label>
        </div>
        <div class="position-notification">
          <type-notification-selection
            :titre="'Candidature « retenu »'"
            :notification-in-app="notification.notifAppCandidatRetenu"
            :notification-mail="notification.notifMailCandidatRetenu"
            :activer-checkbox="false"
            :select-notif="selectNotif1"
            @modif-notif-app="updateNotification((notification.notifAppCandidatRetenu = $event))"
            @modif-notif-mail="updateNotification((notification.notifMailCandidatRetenu = $event))"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Candidature « non-retenu »'"
            :notification-in-app="notification.notifAppCandidatNonRetenu"
            :notification-mail="notification.notifMailCandidatNonRetenu"
            :activer-checkbox="false"
            :select-notif="selectNotif1"
            class="mt-surbrillance"
            @modif-notif-app="updateNotification((notification.notifAppCandidatNonRetenu = $event))"
            @modif-notif-mail="updateNotification((notification.notifMailCandidatNonRetenu = $event))"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Candidature « convoqué »'"
            :notification-in-app="notification.notifAppCandidatConvoque"
            :notification-mail="notification.notifMailCandidatConvoque"
            :activer-checkbox="true"
            :select-notif="null"
          ></type-notification-selection>
          <type-notification-selection
            :titre="'Candidature « non-convoqué »'"
            :notification-in-app="notification.notifAppCandidatNonConvoque"
            :notification-mail="notification.notifMailCandidatNonConvoque"
            :activer-checkbox="true"
            :select-notif="null"
            class="mt-surbrillance"
          ></type-notification-selection>
        </div>
      </article>
    </div>
  </section>
</template>

<script>
import TypeNotificationSelection from '~/components/utilisateur/type-notification-selection';
import { classResolver } from '~/components/mixins/activityMixin';

export default {
  name: 'TypeNotification',
  components: {
    TypeNotificationSelection,
  },
  mixins: [classResolver],
  props: {
    notification: {
      type: Object,
      default: () => ({}),
    },
    typeActivite: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    const selectNotif =
      this.notification.notifAppActiviteCree &&
      this.notification.notifMailActiviteCree &&
      this.notification.notifAppActiviteModif &&
      this.notification.notifMailActiviteModif &&
      this.notification.notifAppCandidatRetenu &&
      this.notification.notifMailCandidatRetenu &&
      this.notification.notifAppCandidatNonRetenu &&
      this.notification.notifMailCandidatNonRetenu;
    const selectNotif1 = selectNotif;
    return {
      idTypeActiviteData: Array.from(this.typeActivite),
      afficherNotif: false,
      selectNotif,
      selectNotif1,
    };
  },
  methods: {
    resolveBorderTypeActivite(typeActivite, prefix) {
      const res = {
        class: `${prefix}none`,
      };
      const typeAct = this.appTypesActivites.find((type) => typeActivite.code === type.code);
      if (typeAct) {
        res.class = `${prefix}${typeAct.codeCss}`;
      }
      return res;
    },
    async updateNotification() {
      const newNotif = await this.$api.notification.modifierNotification(this.notification.id, this.notification);
      this.$emit('update-notification', newNotif);
      this.selectNotif =
        this.notification.notifAppActiviteCree &&
        this.notification.notifMailActiviteCree &&
        this.notification.notifAppActiviteModif &&
        this.notification.notifMailActiviteModif &&
        this.notification.notifAppCandidatRetenu &&
        this.notification.notifMailCandidatRetenu &&
        this.notification.notifAppCandidatNonRetenu &&
        this.notification.notifMailCandidatNonRetenu;
      if (!this.selectNotif) {
        this.selectNotif1 = null;
      }
    },
    changeSwitch() {
      this.selectNotif1 = this.selectNotif;
    },
  },
};
</script>

<style scoped lang="scss">
.position-notification {
  padding-left: 1.2rem;
  margin-top: 0.5rem;
}

.position-titre {
  padding-left: 0.2rem;
  margin-top: 1rem;
}

.position-champ-notif {
  margin-bottom: -0.9rem;
}
</style>
